import {
  json,
  tree,
  select,
  cluster,
  hierarchy,
} from 'd3';

const svg = select('svg');
const g = svg.append('g');
const width = +svg.attr('width');
const height = +svg.attr('height');
var data;

const render = () => {
  // Initialize Tree Data Structure
  // var root = hierarchy(data);
  // var treeLayout = tree();
  // treeLayout.size([400,200]);
  // treeLayout(root);
  
  // Initialize Cluster Data Structure
  var clusterLayout = cluster()
    .size([400,200]);
  var root = hierarchy(data);
  clusterLayout(root);
  
  
  
  // Nodes
  svg.append('g')
    .attr('transform', `translate(${width/4},${height/4})`)
    .selectAll('circle.node')
    .data(root.descendants())
    .enter()
    .append('circle')
    	.classed('node', true)
      .attr('cx', (d) => d.x)
      .attr('cy', (d) => d.y)
      .attr('r', 4);
  
  // Links
  svg.append('g')
    .attr('transform', `translate(${width/4},${height/4})`)
    .selectAll('line.link')
    .data(root.links())
    .enter()
    .append('line')
    	.classed('link', true)
    	.attr('x1', (d) => d.source.x)
      .attr('y1', (d) => d.source.y)
      .attr('x2', (d) => d.target.x)
      .attr('y2', (d) => d.target.y);
  
};

json('data.json').then((loadedData) => {
	data = loadedData;
  render()
});


















